=== debian/changelog ===
netopeer2 (1.1.39-1) unstable; urgency=low

  * Initial packaging (Closes: #976705)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 4 Dec 2020 09:02:12 +0100
