=== debian/control ===
Source: netopeer2
Section: libs
Maintainer: Ondřej Surý <ondrej@debian.org>
Priority: optional
Standards-Version: 4.5.1.0
Build-Depends: adduser,
               cmake,
               debhelper-compat (= 12),
               graphviz,
               libnetconf2-dev,
               libssh-dev,
               libssl-dev,
               libsysrepo-dev,
               libyang-dev (>= 1.0.182),
               pkg-config,
               sysrepo
Homepage: https://github.com/CESNET/Netopeer2

Package: netopeer2
Depends: openssl,
         sysrepo,
         ${misc:Depends},
         ${shlibs:Depends}
Section: admin
Architecture: any
Description: server for implementing network configuration management
 Netopeer2 is a server for implementing network configuration management based
 on the NETCONF Protocol. This is the second generation, originally available as
 the Netopeer project. Netopeer2 is based on the new generation of the NETCONF
 and YANG libraries - libyang and libnetconf2. The Netopeer2 server uses sysrepo
 as a NETCONF datastore implementation.
