=== debian/changelog ===
netopeer2 (2.0.35-1ubuntu1) jammy; urgency=medium

  * d/p/0003-fix-ftbfs-32bits.patch: fix test failure on 32bits
    (LP: #1954837)

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 15 Dec 2021 14:42:44 -0300

netopeer2 (2.0.35-1) unstable; urgency=medium

  * New upstream version 2.0.35
  * Bump the Build-Dependencies to >= 2.0.0 versions of libyang2,
    libnetconf2 and sysrepo libraries
  * Disable merge_listen_config at compile time
  * Install remove.sh and use it in postinst
  * Set server_dir to follow FHS
  * Use system sysrepoctl
  * Add netopeer-server man page
  * Switch the service type to simple as it does not fork
  * Depend on sysrepo that cleans up /etc/sysrepo on upgrade
  * Run make test_clean on failed tests
  * Cleanup tests after successful build
  * Disable test_sub_ntf_advanced; it's flaky
  * Use restricted shell when executing bash in postinst/postrm scripts
  * Allow overriding openssl binary path

 -- Ondřej Surý <ondrej@debian.org>  Fri, 26 Nov 2021 13:34:29 +0100
