=== debian/control ===
--- 
+++ 
@@ -1,24 +1,26 @@
 Source: netopeer2
 Section: libs
-Maintainer: Ondřej Surý <ondrej@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
 Priority: optional
 Standards-Version: 4.5.1.0
 Build-Depends: adduser,
                cmake,
                debhelper-compat (= 12),
                graphviz,
-               libnetconf2-dev,
+               libcmocka-dev,
+               libnetconf2-dev (>= 2.0.0),
                libssh-dev,
                libssl-dev,
-               libsysrepo-dev,
-               libyang-dev (>= 1.0.182),
+               libsysrepo-dev (>= 2.0.0),
+               libyang2-dev (>= 2.0.0),
                pkg-config,
-               sysrepo
+               sysrepo (>= 2.0.0)
 Homepage: https://github.com/CESNET/Netopeer2
 
 Package: netopeer2
 Depends: openssl,
-         sysrepo,
+         sysrepo (>= 2.0.53-4~),
          ${misc:Depends},
          ${shlibs:Depends}
 Section: admin
